<?php



/**
 * Written by David Smith
 * nopeer@gmail.com
 *
 * For ATNF CSIRO
 *
 * This form presents a login dialog.
 */



require_once GREEN_ZONE_DIR . 'Forms/GZ_BaseForm.php';
require_once 'Classes/General/UserData.php';




class LoginForm extends GZ_BaseForm
{
  var $failure;
  var $user_data;

  function __construct( $set_gz )
  {
    parent::__construct( $set_gz );

    $this->failure = false;

    $this->user_data = new UserData();
  }


  function LoggedIn()
  {
    $logged_in = false;
    
    if( $this->user_data != '' )
    {
      $method = $this->user_data->GetAuthType();
      if( $method == 'anonymous' || $method == 'opal' )
	$logged_in = true;
    }
    
    return $logged_in;
  }


  function Login()
  {
    global $_SESSION;

    if( $this->GetPostString('authenticateType') == 'anon' )
    {
      if( !is_string( $this->GetPostString('email') ) ||
          strlen( $this->GetPostString('email') ) < 4 ||
          strpos( $this->GetPostString('email'), '@' ) === false ||
          strpos( $this->GetPostString('email'), '.' ) === false )
        throw new GZ_Exception( 'Enter a valid email address', 'LoginForm::Login' );

      if( $this->user_data == '' )
        $this->user_data = new UserData();
    
      $this->user_data->SetEmail( $this->GetPostString( 'email' ) );
      $this->user_data->SetAuthType( 'anonymous' );
    }
    else if ( $this->GetPostString('authenticateType') == 'opal' )
    {
        $username = strtolower( $this->GetPostString( 'opalEmail' ) );
        $password = $this->GetPostString( 'opalPassword' );  
  
        $tns = 
          "(DESCRIPTION =
            (ADDRESS_LIST =
              (ADDRESS = (PROTOCOL = TCP)(HOST = serapis.atnf.csiro.au)(PORT = 1521))
            )
            (CONNECT_DATA =
              (SERVICE_NAME = atoa.atnf.csiro.au)
            )
          )" ;
        
  //   $dbaddress = 'oci:dbname=serapis.atnf.csiro.au:1521:atoa' ;
  $dbaddress = "oci:dbname=".$tns ;
   
  // Database user
  $dbuser = 'authenticator' ;
  // Database pasword
  $dbpass = 'highintegrity' ; 
  $dbh = new PDO( $dbaddress, $dbuser, $dbpass ) ;
  
  
  $email = $dbh->quote( $username ) ;
  if ( $email === false ) // the driver does not support quoting
    {  $email = str_replace( "'", "\\'", $username ) ;
      $email = "'".$email."'" ;
    }
  
  $sql = "SELECT hash FROM opalprod.password p, opalprod.atuser a WHERE a.id = p.userid AND lower(a.email)=".$email ;
  $result = $dbh->query( $sql ) ;
  
  echo 'opal query peformed <br>';

  
  
//   if ( $result === false )  db_report_error1( $dbh ) ;
//   $row = $result->fetch( PDO::FETCH_NUM ) ;      
//   if ( !$row ) return false ; // no such user
//   $hash = md5( $password  ) ;
//   if ( $hash != $row[0] ) return false ; // wrong password
//   return true ;
    }

    // TODO add opal login code here
  }



  function Logout()
  {
    global $_SESSION;

    if( $this->user_data != '' )
      $this->user_data->RemoveFromSession();
    foreach( $_SESSION as $name => $value )
      unset( $_SESSION[$name] );
  }



  function Display()
  {
    global $_SERVER;

    $smarty = $this->gz->CreateSmarty();

    $logged_in = $this->LoggedIn();
    $proprietary_period = 12;
    $self = $_SERVER['PHP_SELF'];

    $this->gz->smarty_assign( $smarty, 'logged_in', $logged_in );
    $this->gz->smarty_assign( $smarty, 'proprietary_period', $propietary_period );
    $this->gz->smarty_assign( $smarty, 'self', $self );

    $smarty->Display( 'LoginForm.tpl' );
  }


  function ProcessActions()
  {
    if( $this->ActionIs( 'Login' ) )
      $this->Login();
    else if( $this->ActionIs( 'Logout' ) )
      $this->Logout();

    if( $this->LoggedIn() )
      return 'QueryForm';
    else
      return '';
  }
};






?>